//http://seta43.duckdns.org/
//http://seta43.blogspot.com/
//xsetaseta@gmail.com
// SETA43
// Programa hecho por JUAN GALAZ
//30/03/2021


#include <avr/io.h>
#include <avr/interrupt.h>


#define DELAY_LCD  4

#define BUTTON1 A4
#define BUTTON2 A5

#define SEGA 2
#define SEGB 3
#define SEGC 4
#define SEGD 5
#define SEGE 6
#define SEGF 7
#define SEGG 8
#define SEGX 9

#define DIGITO1 nada
#define DIGITO2 nada
#define DIGITO3 10
#define DIGITO4 11
#define DIGITO5 12
#define DIGITO6 13
#define DIGITO7 14
#define DIGITO8 15
#define DIGITO9 16
#define DIGITO10 17


                        //0,1,2,3,4,5,6,7,8,9,SPACE,
unsigned char numerosD[12]={129,243,73,97,51 ,37,5,241,1,33,255};
unsigned char digitos[13]={1,2,3,4,5,6,7,8};

int horas=20, minutos, segundos, dias;
byte bandera = 0;
char time[15];

bool parpadeo;

void printDigito(unsigned char num, unsigned char dig )
{
 unsigned char dato;
 
    if(num<11) dato=numerosD[num];

    switch(dig)
    {
      case 3:
      digitalWrite(DIGITO3, LOW);
      digitalWrite(DIGITO4, HIGH); digitalWrite(DIGITO5, HIGH);
      digitalWrite(DIGITO6, HIGH); digitalWrite(DIGITO7, HIGH);
      digitalWrite(DIGITO8, HIGH); digitalWrite(DIGITO8, HIGH);
      digitalWrite(DIGITO10, HIGH);
      if(dato==73) dato=203;
      break;
      case 4:
      digitalWrite(DIGITO4, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO5, HIGH);
      digitalWrite(DIGITO6, HIGH); digitalWrite(DIGITO7, HIGH);
      digitalWrite(DIGITO8, HIGH); digitalWrite(DIGITO9, HIGH);
      digitalWrite(DIGITO10, HIGH);
      break;
      case 5:
      digitalWrite(DIGITO5, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO4, HIGH);
      digitalWrite(DIGITO6, HIGH); digitalWrite(DIGITO7, HIGH);
      digitalWrite(DIGITO8, HIGH); digitalWrite(DIGITO9, HIGH);
      digitalWrite(DIGITO10, HIGH);
      break;
      case 6:
      digitalWrite(DIGITO6, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO4, HIGH);
      digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO7, HIGH);
      digitalWrite(DIGITO8, HIGH); digitalWrite(DIGITO9, HIGH);
      digitalWrite(DIGITO10, HIGH);
      break;
      case 7:
      digitalWrite(DIGITO7, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO4, HIGH);
      digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO6, HIGH);
      digitalWrite(DIGITO8, HIGH); digitalWrite(DIGITO9, HIGH);
      digitalWrite(DIGITO10, HIGH);
      break;
      case 8:
      digitalWrite(DIGITO8, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO4, HIGH);
      digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO6, HIGH);
      digitalWrite(DIGITO7, HIGH); digitalWrite(DIGITO9, HIGH);
      digitalWrite(DIGITO10, HIGH);
      break;   
      case 9:
      digitalWrite(DIGITO9, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO4, HIGH);
      digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO6, HIGH);
      digitalWrite(DIGITO7, HIGH); digitalWrite(DIGITO8, HIGH);
      digitalWrite(DIGITO10, HIGH);
      break;    
      case 10:
      digitalWrite(DIGITO10, LOW);
      digitalWrite(DIGITO3, HIGH); digitalWrite(DIGITO4, HIGH);
      digitalWrite(DIGITO5, HIGH); digitalWrite(DIGITO6, HIGH);
      digitalWrite(DIGITO7, HIGH); digitalWrite(DIGITO8, HIGH);
      digitalWrite(DIGITO9, HIGH);
      if(parpadeo==1) 
        dato=255;
        else
        dato=70;
      break;     
    }
    
    if(dato&1)  digitalWrite(SEGX,HIGH ); else  digitalWrite(SEGX,LOW);  
    if(dato&2)  digitalWrite(SEGA,HIGH ); else  digitalWrite(SEGA,LOW);
    if(dato&4)  digitalWrite(SEGB,HIGH ); else  digitalWrite(SEGB,LOW);
    if(dato&8)  digitalWrite(SEGC,HIGH ); else  digitalWrite(SEGC,LOW);
    if(dato&16)  digitalWrite(SEGD,HIGH ); else  digitalWrite(SEGD,LOW);
    if(dato&32)  digitalWrite(SEGE,HIGH ); else  digitalWrite(SEGE,LOW);
    if(dato&64)  digitalWrite(SEGF,HIGH ); else  digitalWrite(SEGF,LOW);
    if(dato&128)  digitalWrite(SEGG,HIGH ); else  digitalWrite(SEGG,LOW);
}




void displayDigitos(void)
{
  
  printDigito(digitos[2],3); delay(DELAY_LCD);
  printDigito(digitos[3],4); delay(DELAY_LCD);
  printDigito(digitos[4],5); delay(DELAY_LCD);
  printDigito(digitos[5],6); delay(DELAY_LCD);
  printDigito(digitos[6],7); delay(DELAY_LCD);
  printDigito(digitos[7],8); delay(DELAY_LCD);

  printDigito(0,10); delay(DELAY_LCD);
    
}


void setup() 
{
  Serial.begin(9600);
  // put your setup code here, to run once:
  pinMode(13, OUTPUT);
  pinMode(SEGA, OUTPUT);
  pinMode(SEGB, OUTPUT);
  pinMode(SEGC, OUTPUT);
  pinMode(SEGD, OUTPUT);
  pinMode(SEGE, OUTPUT);
  pinMode(SEGF, OUTPUT);
  pinMode(SEGG, OUTPUT);

  
  
  pinMode(DIGITO3, OUTPUT);
  pinMode(DIGITO4, OUTPUT);
  pinMode(DIGITO5, OUTPUT);
  pinMode(DIGITO6, OUTPUT);
  pinMode(DIGITO7, OUTPUT);
  pinMode(DIGITO8, OUTPUT);
 
  pinMode(BUTTON1, INPUT);
  pinMode(BUTTON2, INPUT); 

  cli();
  TCCR1A = 0;
  TCCR1B = 0;
  //OCR1A = 15624;
  OCR1A = 15624;
  TCCR1B |= (1 << WGM12);
  TCCR1B |= (1 << CS10);
  TCCR1B |= (1 << CS12);
  TIMSK1 = (1 << OCIE1A);
  sei();
  
}

void loop() 
{

   if(LOW==digitalRead(BUTTON1))
    {
      minutos++;
      if(minutos>59) minutos=0;
      segundos=0;
      bandera=1;
      delay(200);
    }
   if(LOW==digitalRead(BUTTON2))
    {
      horas++;
      if(horas>23) horas=0;
      bandera=1;
      delay(200);
    }


  if (bandera == 1)
    {
      bandera = 0;
      printTime();
    } 
    displayDigitos();
}



void printTime()
{
  sprintf(time, "%02d:%02d:%02d", horas, minutos, segundos);

  digitos[7]=time[7]-48;
  digitos[6]=time[6]-48;
  digitos[5]=time[4]-48;
  digitos[4]=time[3]-48;
  digitos[3]=time[1]-48;
  digitos[2]=time[0]-48;
  if(time[0]=='0')digitos[2]=10;
                                                                                                                                       
  Serial.println(time);
}


ISR(TIMER1_COMPA_vect)
{
  if(parpadeo==1)parpadeo=0; else parpadeo=1;
  bandera = 1;
  segundos++;
  if (segundos > 59)
  {
    segundos = 0;
    minutos++;
    if (minutos > 59)
    {
      minutos = 0;
      horas++;
      if (horas > 23)
      {
        segundos = 0;
        minutos = 0;
        horas = 0;
        dias++;
      }
    }
  }
}
